jjb: Update java CLASSPATH for sles15sp5
[lttng-ci.git] / scripts / lttng-tools / build.sh
index 84de8fa88f7c6d61792dde6e18597153fd8095e1..c4b4fdb084fc91bcc1a20862de9cec3f2f8048e7 100755 (executable)
-#!/bin/bash -exu
+#!/bin/bash
 #
-# Copyright (C) 2016 - Jonathan Rajotte-Julien <jonathan.rajotte-julien@efficios.com>
-#                      Michael Jeanson <mjeanson@efficios.com>
+# SPDX-FileCopyrightText: 2016 Jonathan Rajotte-Julien <jonathan.rajotte-julien@efficios.com>
+# SPDX-FileCopyrightText: 2016-2023 Michael Jeanson <mjeanson@efficios.com>
+# SPDX-License-Identifier: GPL-2.0-or-later
 #
-# This program is free software: you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation, either version 3 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program.  If not, see <http://www.gnu.org/licenses/>.
+# shellcheck disable=SC2103
+
+set -exu
 
 # Version compare functions
+vercomp () {
+    set +u
+    if [[ "$1" == "$2" ]]; then
+        return 0
+    fi
+    local IFS=.
+    # Ignore the shellcheck warning, we want splitting to happen based on IFS.
+    # shellcheck disable=SC2206
+    local i ver1=($1) ver2=($2)
+    # fill empty fields in ver1 with zeros
+    for ((i=${#ver1[@]}; i<${#ver2[@]}; i++)); do
+        ver1[i]=0
+    done
+    for ((i=0; i<${#ver1[@]}; i++)); do
+        if [[ -z ${ver2[i]} ]]; then
+            # fill empty fields in ver2 with zeros
+            ver2[i]=0
+        fi
+        if ((10#${ver1[i]} > 10#${ver2[i]})); then
+            return 1
+        fi
+        if ((10#${ver1[i]} < 10#${ver2[i]})); then
+            return 2
+        fi
+    done
+    set -u
+    return 0
+}
+
 verlte() {
-    [  "$1" = "`printf '%s\n%s' $1 $2 | sort -V | head -n1`" ]
+    vercomp "$1" "$2"; local res="$?"
+    [ "$res" -eq "0" ] || [ "$res" -eq "2" ]
 }
 
 verlt() {
-    [ "$1" = "$2" ] && return 1 || verlte $1 $2
+    vercomp "$1" "$2"; local res="$?"
+    [ "$res" -eq "2" ]
 }
 
 vergte() {
-    [  "$1" = "`printf '%s\n%s' $1 $2 | sort -V | tail -n1`" ]
+    vercomp "$1" "$2"; local res="$?"
+    [ "$res" -eq "0" ] || [ "$res" -eq "1" ]
 }
 
 vergt() {
-    [ "$1" = "$2" ] && return 1 || vergte $1 $2
+    vercomp "$1" "$2"; local res="$?"
+    [ "$res" -eq "1" ]
 }
 
+verne() {
+    vercomp "$1" "$2"; local res="$?"
+    [ "$res" -ne "0" ]
+}
 
-# Create build directory
-rm -rf $WORKSPACE/build
-mkdir -p $WORKSPACE/build
+print_header() {
+    set +x
 
-# liburcu
-URCU_INCS="$WORKSPACE/deps/liburcu/build/include/"
-URCU_LIBS="$WORKSPACE/deps/liburcu/build/lib/"
+    local message=" $1 "
+    local message_len
+    local padding_len
 
-# lttng-ust
-UST_INCS="$WORKSPACE/deps/lttng-ust/build/include/"
-UST_LIBS="$WORKSPACE/deps/lttng-ust/build/lib/"
-UST_JAVA="$WORKSPACE/deps/lttng-ust/build/share/java/"
+    message_len="${#message}"
+    padding_len=$(( (80 - (message_len)) / 2 ))
 
-# babeltrace
-BABEL_INCS="$WORKSPACE/deps/babeltrace/build/include/"
-BABEL_LIBS="$WORKSPACE/deps/babeltrace/build/lib/"
-BABEL_BINS="$WORKSPACE/deps/babeltrace/build/bin/"
 
-PREFIX="$WORKSPACE/build"
+    printf '\n'; printf -- '#%.0s' {1..80}; printf '\n'
+    printf -- '-%.0s' {1..80}; printf '\n'
+    printf -- '#%.0s' $(seq 1 $padding_len); printf '%s' "$message"; printf -- '#%.0s' $(seq 1 $padding_len); printf '\n'
+    printf -- '-%.0s' {1..80}; printf '\n'
+    printf -- '#%.0s' {1..80}; printf '\n\n'
 
-# Set platform variables
-case "$arch" in
-solaris10)
-    MAKE=gmake
-    TAR=gtar
-    NPROC=gnproc
-    BISON="bison"
-    YACC="$BISON -y"
-    CFLAGS="-D_XOPEN_SOURCE=1 -D_XOPEN_SOURCE_EXTENDED=1 -D__EXTENSIONS__=1"
-    RUN_TESTS="no"
+    set -x
+}
+
+failed_configure() {
+    # Assume we are in the configured build directory
+    print_header "BEGIN config.log"
+    cat config.log
+    print_header "END config.log"
+
+    # End the build with failure
+    exit 1
+}
+
+set_execute_traversal_bit()
+{
+    path=$1
+
+    level="$path"
+    if [ ! -d "$path" ]; then
+        fail "Path is not a directory"
+    fi
+    while level="$(dirname "$level")"
+    do
+        if [ "$level" = / ]; then
+            break
+        fi
+        chmod a+x "$level"
+    done
+    chmod a+x "$path"
+}
+
+print_header "LTTng-tools build script starting"
+
+# Required variables
+WORKSPACE=${WORKSPACE:-}
+
+# Axis
+platform=${platform:-}
+conf=${conf:-}
+build=${build:-}
+cc=${cc:-}
+
+# Build steps that can be overriden by the environment
+LTTNG_TOOLS_MAKE_INSTALL="${LTTNG_TOOLS_MAKE_INSTALL:-yes}"
+LTTNG_TOOLS_MAKE_CLEAN="${LTTNG_TOOLS_MAKE_CLEAN:-yes}"
+LTTNG_TOOLS_GEN_COMPILE_COMMANDS="${LTTNG_TOOLS_GEN_COMPILE_COMMANDS:-no}"
+LTTNG_TOOLS_RUN_TESTS="${LTTNG_TOOLS_RUN_TESTS:-yes}"
+LTTNG_TOOLS_RUN_TESTS_LONG_REGRESSION="${LTTNG_TOOLS_RUN_TESTS_LONG_REGRESSION:-no}"
+LTTNG_TOOLS_RUN_UST_JAVA_TESTS="${LTTNG_TOOLS_RUN_UST_JAVA_TESTS:-yes}"
+LTTNG_TOOLS_CLANG_TIDY="${LTTNG_TOOLS_CLANG_TIDY:-no}"
+
+SRCDIR="$WORKSPACE/src/lttng-tools"
+TAPDIR="$WORKSPACE/tap"
+PREFIX="/build"
+LIBDIR="lib"
+LIBDIR_ARCH="$LIBDIR"
+
+# RHEL and SLES both use lib64 but don't bother shipping a default autoconf
+# site config that matches this.
+if [[ ( -f /etc/redhat-release || -f /etc/products.d/SLES.prod || -f /etc/yocto-release ) ]]; then
+    # Detect the userspace bitness in a distro agnostic way
+    if file -L /bin/bash | grep '64-bit' >/dev/null 2>&1; then
+        LIBDIR_ARCH="${LIBDIR}64"
+    fi
+fi
+
+DEPS_INC="$WORKSPACE/deps/build/include"
+DEPS_LIB="$WORKSPACE/deps/build/$LIBDIR_ARCH"
+DEPS_PKGCONFIG="$DEPS_LIB/pkgconfig"
+DEPS_BIN="$WORKSPACE/deps/build/bin"
+DEPS_JAVA="$WORKSPACE/deps/build/share/java"
+
+export PATH="$DEPS_BIN:$PATH"
+export LD_LIBRARY_PATH="$DEPS_LIB:${LD_LIBRARY_PATH:-}"
+export PKG_CONFIG_PATH="$DEPS_PKGCONFIG"
+export CPPFLAGS="-I$DEPS_INC"
+export LDFLAGS="-L$DEPS_LIB"
+
+exit_status=0
+
+# Use bear to generate compile_commands.json when enabled
+BEAR=""
+if [ "$LTTNG_TOOLS_GEN_COMPILE_COMMANDS" = "yes" ]; then
+       BEAR="bear"
+fi
+
+# Create tmp directory
+TMPDIR="$WORKSPACE/tmp"
+mkdir -p "$TMPDIR"
+
+# Use a symlink in /tmp to point to the the tmp directory
+# inside the workspace, this is to work around the path length
+# limit of unix sockets which are created by the test suite.
+tmpdir="$(mktemp)"
+ln -sf "$TMPDIR" "$tmpdir"
+export TMPDIR="$tmpdir"
+
+# Create a symlink to "babeltrace" when the "babeltrace2" executable is found.
+# This is a temporary workaround until lttng-tools either allows the override of
+# the trace reader in its test suite or that we move to only supporting
+# babeltrace2
+if [ -x "$DEPS_BIN/babeltrace2" ]; then
+    ln -s "$DEPS_BIN/babeltrace2" "$DEPS_BIN/babeltrace"
+fi
+
+# When using babeltrace2 make sure that it finds its plugins and
+# plugin-providers.
+export BABELTRACE_PLUGIN_PATH="$DEPS_LIB/babeltrace2/plugins/"
+export LIBBABELTRACE2_PLUGIN_PROVIDER_DIR="$DEPS_LIB/babeltrace2/plugin-providers/"
+
+export CFLAGS="-g -O2"
+export CXXFLAGS="-g -O2"
+
+# Set compiler variables
+case "$cc" in
+gcc)
+    export CC=gcc
+    export CXX=g++
+    ;;
+gcc-*)
+    export CC=gcc-${cc#gcc-}
+    export CXX=g++-${cc#gcc-}
+    ;;
+clang)
+    export CC=clang
+    export CXX=clang++
+    ;;
+clang-*)
+    export CC=clang-${cc#clang-}
+    export CXX=clang++-${cc#clang-}
     ;;
+*)
+    if [ "x$cc" != "x" ]; then
+           export CC="$cc"
+    fi
+    ;;
+esac
 
-solaris11)
-    MAKE=gmake
-    TAR=gtar
-    NPROC=nproc
-    BISON="/opt/csw/bin/bison"
-    YACC="$BISON -y"
-    CFLAGS="-D_XOPEN_SOURCE=1 -D_XOPEN_SOURCE_EXTENDED=1 -D__EXTENSIONS__=1"
-    RUN_TESTS="no"
+# Set platform variables
+case "$platform" in
+macos*)
+    export MAKE=make
+    export TAR=tar
+    export NPROC="getconf _NPROCESSORS_ONLN"
+    export PATH="/opt/local/bin:/opt/local/sbin:$PATH"
+    export CPPFLAGS="-I/opt/local/include $CPPFLAGS"
+    export LDFLAGS="-L/opt/local/lib $LDFLAGS"
+    export PYTHON="python3"
+    export PYTHON_CONFIG="python3-config"
+    ;;
 
-    export PATH="$PATH:/usr/perl5/bin"
+cygwin|cygwin64|msys32|msys64)
+    export MAKE=make
+    export TAR=tar
+    export NPROC=nproc
     ;;
 
 *)
-    MAKE=make
-    TAR=tar
-    NPROC=nproc
-    BISON="bison"
-    YACC="$BISON -y"
-    CFLAGS=""
-    RUN_TESTS="yes"
+    export MAKE=make
+    export TAR=tar
+    export NPROC=nproc
 
     PYTHON2=python2
     PYTHON3=python3
 
-    P2_VERSION=$($PYTHON2 -c "import sys;print(sys.version[:3])")
-    P3_VERSION=$($PYTHON3 -c "import sys;print(sys.version[:3])")
+    if command -v $PYTHON2 >/dev/null 2>&1; then
+        P2_VERSION=$($PYTHON2 -c 'import sys;v = sys.version.split()[0].split("."); print("{}.{}".format(v[0], v[1]))')
+        DEPS_PYTHON2="$WORKSPACE/deps/build/$LIBDIR/python$P2_VERSION/site-packages"
+       if [ "$LIBDIR" != "$LIBDIR_ARCH" ]; then
+            DEPS_PYTHON2="$DEPS_PYTHON2:$WORKSPACE/deps/build/$LIBDIR_ARCH/python$P2_VERSION/site-packages"
+       fi
+    fi
+
+    P3_VERSION=$($PYTHON3 -c 'import sys;v = sys.version.split()[0].split("."); print("{}.{}".format(v[0], v[1]))')
+
+    # Temporary fix for an issue on debian python >= 3.10, add the 'local' prefix
+    DEPS_PYTHON3="$WORKSPACE/deps/build/$LIBDIR/python$P3_VERSION/site-packages:$WORKSPACE/deps/build/local/$LIBDIR/python$P3_VERSION/dist-packages"
+    if [ "$LIBDIR" != "$LIBDIR_ARCH" ]; then
+        DEPS_PYTHON3="$DEPS_PYTHON3:$WORKSPACE/deps/build/$LIBDIR_ARCH/python$P3_VERSION/site-packages"
+    fi
 
-    UST_PYTHON2="$WORKSPACE/deps/lttng-ust/build/lib/python$P2_VERSION/site-packages"
-    UST_PYTHON3="$WORKSPACE/deps/lttng-ust/build/lib/python$P3_VERSION/site-packages"
+    # Most build configs require access to the babeltrace 2 python bindings.
+    # This also makes the lttngust python agent available for `agents` builds.
+    export PYTHONPATH="${DEPS_PYTHON2:-}${DEPS_PYTHON2:+:}$DEPS_PYTHON3"
     ;;
 esac
 
+# Some warning flags are very dumb in GCC 4.8 on SLES12 / EL7, disable them
+# even if they are available.
+if [[ $platform = sles12sp5* ]] || [[  $platform = el7* ]]; then
+    CFLAGS="$CFLAGS -Wno-missing-field-initializers -Wno-shadow"
+    CXXFLAGS="$CXXFLAGS -Wno-missing-field-initializers -Wno-shadow"
+fi
 
-# Run bootstrap prior to configure
-./bootstrap
+# If we have modules, build them
+if [ -d "$WORKSPACE/src/lttng-modules" ]; then
+    print_header "Build and install LTTng-modules"
+    cd "$WORKSPACE/src/lttng-modules"
+    $MAKE -j"$($NPROC)" V=1
+    $MAKE modules_install V=1
+    depmod
+fi
 
-# Get source version from configure script
-eval `grep '^PACKAGE_VERSION=' ./configure`
+# Print build env details
+print_header "Build environment details"
+print_hardware || true
+print_os || true
+print_tooling || true
 
+# Enter the source directory
+cd "$SRCDIR"
 
-# Export build flags
-case "$conf" in
-no-ust)
-    export CPPFLAGS="-I$URCU_INCS"
-    export LDFLAGS="-L$URCU_LIBS"
-    export LD_LIBRARY_PATH="$URCU_LIBS:$BABEL_LIBS:${LD_LIBRARY_PATH:-}"
-    ;;
+# Run bootstrap in the source directory prior to configure
+print_header "Bootstrap autotools"
+./bootstrap
 
-*)
-    export CPPFLAGS="-I$URCU_INCS -I$UST_INCS"
-    export LDFLAGS="-L$URCU_LIBS -L$UST_LIBS"
-    export LD_LIBRARY_PATH="$URCU_LIBS:$UST_LIBS:$BABEL_LIBS:${LD_LIBRARY_PATH:-}"
-    ;;
-esac
+# Get source version from configure script
+eval "$(grep '^PACKAGE_VERSION=' ./configure)"
+PACKAGE_VERSION=${PACKAGE_VERSION//\-pre*/}
 
-# The switch to build without UST changed in 2.8
-if vergte "$PACKAGE_VERSION" "2.8"; then
-    NO_UST="--without-lttng-ust"
-else
-    NO_UST="--disable-lttng-ust"
-fi
+CONF_OPTS=("--prefix=$PREFIX" "--libdir=$PREFIX/$LIBDIR_ARCH" "--disable-maintainer-mode")
+DIST_CONF_OPTS=("--disable-maintainer-mode")
 
-# Set configure options for each build configuration
-CONF_OPTS=""
+# Set configure options and environment variables for each build
+# configuration.
 case "$conf" in
 static)
-    echo "Static build"
-    CONF_OPTS="--enable-static --disable-shared"
-    ;;
+    print_header "Conf: Static lib only"
 
-python-bindings)
-    echo "Build with python bindings"
-    # We only support bindings built with Python 3
-    export PYTHON="python3"
-    export PYTHON_CONFIG="/usr/bin/python3-config"
-    CONF_OPTS="--enable-python-bindings"
+    CONF_OPTS+=("--enable-static" "--disable-shared" "--enable-python-bindings")
     ;;
 
 no-ust)
-    echo "Build without UST support"
-    CONF_OPTS="$NO_UST"
-    ;;
+    print_header "Conf: Without UST support"
 
-java-agent)
-    echo "Build with Java Agents"
-    export JAVA_HOME="/usr/lib/jvm/default-java"
-    export CLASSPATH="$UST_JAVA/*:/usr/share/java/*"
-    CONF_OPTS="--enable-test-java-agent-all"
+    CONF_OPTS+=("--without-lttng-ust")
+    DIST_CONF_OPTS+=("--without-lttng-ust")
     ;;
 
-python-agent)
-    echo "Build with python agents"
-    export PYTHONPATH="$UST_PYTHON2:$UST_PYTHON3"
-    CONF_OPTS="--enable-test-python-agent-all"
+agents)
+    print_header "Conf: Java and Python agents"
+
+    if [[ -z "${JAVA_HOME:-}" ]] ; then
+        export JAVA_HOME="/usr/lib/jvm/default-java"
+    fi
+    export CLASSPATH="$DEPS_JAVA/lttng-ust-agent-all.jar:/usr/share/java/log4j-api.jar:/usr/share/java/log4j-core.jar:/usr/share/java/log4j-1.2.jar"
+    if [[ -f /etc/products.d/SLES.prod ]] ; then
+        SLES_VERSION="$(grep -E '</version>' /etc/products.d/SLES.prod | grep -E -o '[0-9]+\.[0-9]+')"
+        if vergte "${SLES_VERSION}" "15.5" ; then
+            export CLASSPATH="${DEPS_JAVA}/lttng-ust-agent-all.jar:/usr/share/java/log4j/log4j-api.jar:/usr/share/java/log4j/log4j-core.jar:/usr/share/java/log4j12/log4j-12.jar"
+        fi
+    fi
+
+
+    CONF_OPTS+=("--enable-python-bindings" "--enable-test-java-agent-all")
+
+    # Explicitly add '--enable-test-java-agent-log4j2', it's not part of '-all' in stable 2.12/2.13
+    if verlt "$PACKAGE_VERSION" "2.14"; then
+        CONF_OPTS+=("--enable-test-java-agent-log4j2")
+    fi
+
+    # Some distros don't ship python2 anymore
+    if command -v $PYTHON2 >/dev/null 2>&1; then
+        CONF_OPTS+=("--enable-test-python-agent-all")
+    else
+        CONF_OPTS+=("--enable-test-python3-agent")
+    fi
     ;;
 
 relayd-only)
-    echo "Build relayd only"
-    CONF_OPTS="--disable-bin-lttng --disable-bin-lttng-consumerd --disable-bin-lttng-crash --disable-bin-lttng-sessiond --disable-extras $NO_UST"
+    print_header "Conf: Relayd only"
+
+    CONF_OPTS+=("--disable-bin-lttng" "--disable-bin-lttng-consumerd" "--disable-bin-lttng-crash" "--disable-bin-lttng-sessiond" "--disable-extras" "--disable-man-pages" "--without-lttng-ust")
+    ;;
+
+debug-rcu)
+    print_header "Conf: RCU sanity checks for debugging"
+
+    CONF_OPTS+=("--enable-python-bindings")
+
+    export CPPFLAGS="$CPPFLAGS -DDEBUG_RCU"
     ;;
 
 *)
-    echo "Standard build"
-    CONF_OPTS=""
+    print_header "Conf: Standard"
+
+    CONF_OPTS+=("--enable-python-bindings")
+
+    # Something is broken in docbook-xml on yocto
+    if [[ "$platform" = yocto* ]]; then
+        CONF_OPTS+=("--disable-man-pages")
+    fi
     ;;
 esac
 
-
 # Build type
-# oot : out-of-tree build
-# dist: build via make dist
-# *   : normal tree build
+# oot     : out-of-tree build
+# dist    : build via make dist
+# oot-dist: build via make dist out-of-tree
+# *       : normal tree build
 #
-# Make sure to move to the build_path and run configure
-# before continuing
-BUILD_PATH=$WORKSPACE
+# Make sure to move to the build directory and run configure
+# before continuing.
 case "$build" in
-    oot)
-        echo "Out of tree build"
-        BUILD_PATH=$WORKSPACE/oot
-        mkdir -p $BUILD_PATH
-        cd $BUILD_PATH
-        MAKE=$MAKE BISON="$BISON" YACC="$YACC" CFLAGS="$CFLAGS" $WORKSPACE/configure --prefix=$PREFIX $CONF_OPTS
-        ;;
-
-    dist)
-        echo "Distribution out of tree build"
-        BUILD_PATH=`mktemp -d`
-
-        # Initial configure and generate tarball
-        MAKE=$MAKE BISON="$BISON" YACC="$YACC" CFLAGS="$CFLAGS" ./configure $CONF_OPTS --enable-build-man-pages
-        $MAKE dist
-
-        mkdir -p $BUILD_PATH
-        cp *.tar.* $BUILD_PATH/
-        cd $BUILD_PATH
-
-        # Ignore level 1 of tar
-        $TAR xvf *.tar.* --strip 1
-
-        MAKE=$MAKE BISON="$BISON" YACC="$YACC" CFLAGS="$CFLAGS" $BUILD_PATH/configure --prefix=$PREFIX $CONF_OPTS
-        ;;
-
-    *)
-        BUILD_PATH=$WORKSPACE
-        echo "Standard tree build"
-        MAKE=$MAKE BISON="$BISON" YACC="$YACC" CFLAGS="$CFLAGS" $WORKSPACE/configure --prefix=$PREFIX $CONF_OPTS
-        ;;
+oot)
+    print_header "Build: Out of tree"
+
+    # Create and enter a temporary build directory
+    builddir=$(mktemp -d)
+    cd "$builddir"
+
+    "$SRCDIR/configure" "${CONF_OPTS[@]}" || failed_configure
+    ;;
+
+dist)
+    print_header "Build: Distribution in-tree"
+
+    # Run configure and generate the tar file
+    # in the source directory
+
+    ./configure "${DIST_CONF_OPTS[@]}" || failed_configure
+    $MAKE dist
+
+    # Create and enter a temporary build directory
+    builddir=$(mktemp -d)
+    cd "$builddir"
+
+    # Extract the distribution tar in the build directory,
+    # ignore the first directory level
+    $TAR xvf "$SRCDIR"/*.tar.* --strip 1
+
+    # Build in extracted source tree
+    ./configure "${CONF_OPTS[@]}" || failed_configure
+    ;;
+
+oot-dist)
+    print_header "Build: Distribution Out of tree"
+
+    # Create and enter a temporary build directory
+    builddir=$(mktemp -d)
+    cd "$builddir"
+
+    # Run configure out of tree and generate the tar file
+    "$SRCDIR/configure" "${DIST_CONF_OPTS[@]}" || failed_configure
+    $MAKE dist
+
+    dist_srcdir="$(mktemp -d)"
+    cd "$dist_srcdir"
+
+    # Extract the distribution tar in the new source directory,
+    # ignore the first directory level
+    $TAR xvf "$builddir"/*.tar.* --strip 1
+
+    # Create and enter a second temporary build directory
+    builddir="$(mktemp -d)"
+    cd "$builddir"
+
+    # Run configure from the extracted distribution tar,
+    # out of the source tree
+    "$dist_srcdir/configure" "${CONF_OPTS[@]}" || failed_configure
+    ;;
+
+*)
+    print_header "Build: Standard In-tree"
+    ./configure "${CONF_OPTS[@]}" || failed_configure
+    ;;
 esac
 
+# We are now inside a configured build directory
+
 # BUILD!
-$MAKE -j `$NPROC` V=1
-$MAKE install
+print_header "BUILD!"
+$BEAR ${BEAR:+--} $MAKE -j "$($NPROC)" V=1
 
-# Run tests
-if [ "$RUN_TESTS" = "yes" ]; then
-    cd tests
+# Install in the workspace if enabled
+if [ "$LTTNG_TOOLS_MAKE_INSTALL" = "yes" ]; then
+    print_header "Install"
 
-    # Allow core dumps
-    ulimit -c unlimited
+    $MAKE install V=1 DESTDIR="$WORKSPACE"
+
+    # Cleanup rpath in executables
+    find "$WORKSPACE/$PREFIX/bin" -type f -perm -0500 -exec chrpath --delete {} \;
+
+    # Some configs don't build liblttng-ctl
+    if [ -d "$WORKSPACE/$PREFIX/$LIBDIR_ARCH" ]; then
+        # Cleanup rpath in shared libraries
+        find "$WORKSPACE/$PREFIX/$LIBDIR_ARCH" -name "*.so" -exec chrpath --delete {} \;
+        # Remove libtool .la files
+        find "$WORKSPACE/$PREFIX/$LIBDIR_ARCH" -name "*.la" -delete
+    fi
+fi
+
+# Run clang-tidy on the topmost commit
+if [ "$LTTNG_TOOLS_CLANG_TIDY" = "yes" ]; then
+    print_header "Run clang-tidy"
 
-    # Add 'babeltrace' binary to PATH
-    chmod +x "$BABEL_BINS/babeltrace"
-    export PATH="$PATH:$BABEL_BINS"
+    # This would be better by linting only the lines touched by a patch but it
+    # doesn't seem to work, the lines are always filtered and no error is
+    # reported.
+    #git diff -U0 HEAD^ | clang-tidy-diff -p1 -j "$($NPROC)" -timeout 60 -fix
 
-    # Prepare tap output dirs
-    rm -rf "$WORKSPACE/tap"
-    mkdir -p "$WORKSPACE/tap"
-    mkdir -p "$WORKSPACE/tap/unit"
-    mkdir -p "$WORKSPACE/tap/fast_regression"
-    mkdir -p "$WORKSPACE/tap/with_bindings_regression"
+    # Instead, run clan-tidy on all the files touched by the patch.
+    while read -r filepath; do
+        if [[ "$filepath" =~ (\.cpp|\.hhp|\.c|\.h)$ ]]; then
+            clang-tidy --fix-errors "$(realpath "$filepath")"
+        fi
+    done < <(git diff-tree --no-commit-id --diff-filter=d --name-only -r HEAD)
+
+    # If the tree has local changes, the formatting was incorrect
+    GIT_DIFF_OUTPUT=$(git diff)
+    if [ -n "$GIT_DIFF_OUTPUT" ]; then
+        echo "Saving clang-tidy proposed fixes in clang-tidy-fixes.diff"
+        git diff > "$WORKSPACE/clang-tidy-fixes.diff"
+
+        # Restore the unfixed files so they can be viewed in the warnings web
+        # interface
+        git checkout .
+        exit_status=1
+    fi
+fi
+
+# Run tests for all configs except 'no-ust' / 'relayd-only'
+if [ "$LTTNG_TOOLS_RUN_TESTS" = "yes" ] && [[ ! "$conf" =~ (no-ust|relayd-only) ]]; then
+    print_header "Run test suite"
+
+    # Allow core dumps
+    ulimit -c unlimited
 
     # Force the lttng-sessiond path to /bin/true to prevent the spawing of a
     # lttng-sessiond --daemonize on "lttng create"
     export LTTNG_SESSIOND_PATH="/bin/true"
 
-    # Run 'unit_tests' and 'fast_regression' test suites for all configs except 'no-ust'
-    if [ "$conf" != "no-ust" ]; then
-        # Run 'unit_tests', 2.8 and up has a new test suite
-        if vergte "$PACKAGE_VERSION" "2.8"; then
-            make check
-            rsync -a --exclude 'test-suite.log' --include '*/' --include '*.log' --exclude='*'" $BUILD_PATH/tests/" "$WORKSPACE/tap"
-        else
-            prove --merge -v --exec '' - < "$BUILD_PATH/tests/unit_tests" --archive "$WORKSPACE/tap/unit/" || true
-            prove --merge -v --exec '' - < "$BUILD_PATH/tests/fast_regression" --archive "$WORKSPACE/tap/fast_regression/" || true
-        fi
-    else
-        # Regression is disabled for now, we need to adjust the testsuite for no ust builds.
-        echo "Tests disabled for 'no-ust'."
+    # It is implied that tests depending on LTTNG_ENABLE_DESTRUCTIVE_TESTS
+    # only run for the root user. Note that here `destructive` means that
+    # operations are performed at the host level (add user etc.) that
+    # effectively modify the host. Running those tests are acceptable on our
+    # CI and root jobs since we always run root tests against a `snapshot`
+    # of the host.
+    if [ "$(id -u)" == "0" ]; then
+        # Allow the traversal of all directories leading to the
+        # DEPS_LIBS directory to enable test app run by temp users to
+        # access lttng-ust.
+        set_execute_traversal_bit "$DEPS_LIB"
+        # Allow `all` to interact with all deps libs.
+        chmod a+rwx -R "$DEPS_LIB"
+
+        export LTTNG_ENABLE_DESTRUCTIVE_TESTS="will-break-my-system"
+
+        # Some destructive tests play with the system clock, disable timesyncd
+        systemctl stop systemd-timesyncd.service || true
     fi
 
-    # Run 'with_bindings_regression' test suite for 'python-bindings' config
-    if [ "$conf" = "python-bindings" ]; then
-        prove --merge -v --exec '' - < "$WORKSPACE/tests/with_bindings_regression" --archive "$WORKSPACE/tap/with_bindings_regression/" || true
-    fi
+    make --keep-going check || exit_status=1
 
-    # TAP plugin is having a hard time with .yml files.
-    find "$WORKSPACE/tap" -name "meta.yml" -exec rm -f {} \;
+        # Copy tap logs for the jenkins tap parser before cleaning the build dir
+    rsync -a --exclude 'test-suite.log' --include '*/' --include '*.log' --exclude='*' tests/ "$TAPDIR"
 
-    # And also with files without extension, so rename all result to *.tap
-    find "$WORKSPACE/tap/" -type f -exec mv {} {}.tap \;
+    # Copy the test suites top-level log which includes all tests failures
+    rsync -a --include 'test-suite.log' --include '*/' --exclude='*' tests/ "$WORKSPACE/log"
+
+    if [ "$LTTNG_TOOLS_RUN_TESTS_LONG_REGRESSION" = "yes" ]; then
+        print_header "Run long regression tests"
+        cd tests
+        mkdir -p "$TAPDIR/long_regression"
+        prove --merge -v --exec '' - < long_regression --archive "$TAPDIR/long_regression/" || exit_status=1
+        cd ..
+    fi
 
-    cd -
+    if [ "$LTTNG_TOOLS_RUN_UST_JAVA_TESTS" = "yes" ] && [ "$LTTNG_TOOLS_MAKE_INSTALL" = "yes" ] && [ "$conf" = "agents" ] ; then
+        print_header "Run lttng-ust-java-tests"
+        # Git Source
+        LTTNG_UST_JAVA_TESTS_GIT_SOURCE="${LTTNG_UST_JAVA_TESTS_GIT_SOURCE:-https://github.com/lttng/lttng-ust-java-tests.git}"
+        LTTNG_UST_JAVA_TESTS_GIT_BRANCH="${LTTNG_UST_JAVA_TESTS_GIT_BRANCH:-master}"
+
+        OWD="$(pwd)"
+        cd ..
+        git clone -b "${LTTNG_UST_JAVA_TESTS_GIT_BRANCH}" "${LTTNG_UST_JAVA_TESTS_GIT_SOURCE}" lttng-ust-java-tests
+        cd lttng-ust-java-tests
+
+        LTTNG_UST_JAVA_TESTS_ENV=(
+            # Some ci nodes (eg. SLES12) don't have maven distributed by their
+            # package manager. As a result, the maven binary is deployed in
+            # '/opt/apache/maven/bin'.
+            PATH="${WORKSPACE}/build/bin/:$PATH:/opt/apache/maven/bin/"
+            LD_LIBRARY_PATH="${WORKSPACE}/build/${LIBDIR}/:${WORKSPACE}/build/${LIBDIR_ARCH}:$LD_LIBRARY_PATH"
+            LTTNG_UST_DEBUG=1
+            LTTNG_CONSUMERD32_BIN="${WORKSPACE}/build/${LIBDIR_ARCH}/lttng/libexec/lttng-consumerd"
+            LTTNG_CONSUMERD64_BIN="${WORKSPACE}/build/${LIBDIR_ARCH}/lttng/libexec/lttng-consumerd"
+            LTTNG_SESSION_CONFIG_XSD_PATH="${WORKSPACE}/build/share/xml/lttng"
+            BABELTRACE_PLUGIN_PATH="${WORKSPACE}/deps/build/${LIBDIR_ARCH}/babeltrace2/plugins"
+            LIBBABELTRACE2_PLUGIN_PROVIDER_DIR="${WORKSPACE}/deps/build/${LIBDIR_ARCH}/babeltrace2/plugin-providers"
+        )
+        LTTNG_UST_JAVA_TESTS_MAVEN_OPTS=(
+            "-Dmaven.test.failure.ignore=true"
+            "-Dcommon-jar-location=${WORKSPACE}/deps/build/share/java/lttng-ust-agent-common.jar"
+            "-Djul-jar-location=${WORKSPACE}/deps/build/share/java/lttng-ust-agent-jul.jar"
+            "-Dlog4j-jar-location=${WORKSPACE}/deps/build/share/java/lttng-ust-agent-log4j.jar"
+            "-Dlog4j2-jar-location=${WORKSPACE}/deps/build/share/java/lttng-ust-agent-log4j2.jar"
+            "-DargLine=-Djava.library.path=${WORKSPACE}/deps/build/${LIBDIR_ARCH}"
+            '-Dgroups=!domain:log4j2'
+        )
+        env "${LTTNG_UST_JAVA_TESTS_ENV[@]}" mvn -version
+        mkdir -p "${WORKSPACE}/log"
+        env "${LTTNG_UST_JAVA_TESTS_ENV[@]}" lttng-sessiond -b -vvv 1>"${WORKSPACE}/log/lttng-ust-java-tests-lttng-sessiond.log" 2>&1
+        env "${LTTNG_UST_JAVA_TESTS_ENV[@]}" mvn "${LTTNG_UST_JAVA_TESTS_MAVEN_OPTS[@]}" clean verify || exit_status=1
+        killall lttng-sessiond
+
+        cd "${OWD}"
+    fi
 fi
 
-# Cleanup
-$MAKE clean
+if [ "$LTTNG_TOOLS_RUN_TESTS" = "yes" ] && [[ "$conf" =~ (no-ust|relayd-only) ]]; then
+    # The TAP plugin will fail the job if no test logs are present
+    mkdir -p "$TAPDIR/no-tests"
+    echo "1..1" > "$TAPDIR/no-tests/tests.log"
+    echo "ok 1 - Test suite disabled" >> "$TAPDIR/no-tests/tests.log"
+fi
 
-# Cleanup rpath in executables and shared libraries
-find "$WORKSPACE/build/bin" -type f -perm -0500 -exec chrpath --delete {} \;
-find "$WORKSPACE/build/lib" -name "*.so" -exec chrpath --delete {} \;
+# Clean the build directory
+if [ "$LTTNG_TOOLS_MAKE_CLEAN" = "yes" ]; then
+    print_header "Clean"
+    $MAKE clean
+fi
 
-# Remove libtool .la files
-find "$WORKSPACE/build/lib" -name "*.la" -exec rm -f {} \;
+print_header "LTTng-tools build script ended with: $(test $exit_status == 0 && echo SUCCESS || echo FAILURE)"
 
-# Clean temp dir for dist build
-if [ "$build" = "dist" ]; then
-    cd "$WORKSPACE"
-    rm -rf "$BUILD_PATH"
-fi
+# Exit with failure if any of the tests failed
+exit $exit_status
 
 # EOF
+# vim: expandtab tabstop=4 shiftwidth=4
This page took 0.031674 seconds and 4 git commands to generate.